// written using the tutorial on learnopengl.com
#version 330

in vec2 TexCoords;

out vec4 FragColor;

uniform sampler2D image;
uniform bool horizontal;

uniform float weight[5] = float[] (0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);

void main()
{
	vec2 tex_offset = 3.0f / textureSize(image, 0);
	vec3 result = texture(image, TexCoords).rgb * weight[0];
	if(horizontal)
	{
		for (int i = 1; i < 5; ++i)
		{
			result += texture(image, TexCoords + vec2(tex_offset.x * i, 0.0f)).rgb * weight[i];
			result += texture(image, TexCoords - vec2(tex_offset.x * i, 0.0f)).rgb * weight[i];
		}
	} else
	{
		for (int i = 1; i < 5; ++i)
		{
			result += texture(image, TexCoords + vec2(0.0f, tex_offset.y * i)).rgb * weight[i];
			result += texture(image, TexCoords - vec2(0.0f, tex_offset.y * i)).rgb * weight[i];
		}
	}
	FragColor = vec4(result, 1.0f);
}