#version 330

layout (location = 0) in vec3 squareVertices;
layout (location = 1) in vec4 xyzs;
layout (location = 2) in vec4 color;

uniform vec3 CameraRight_worldspace;
uniform vec3 CameraUp_worldspace;
uniform mat4 view;
uniform mat4 projection;

out vec4 ParticleColor;

void main()
{
	float particleSize = xyzs.w;
	vec3 particleCenter_worldspace = xyzs.xyz;
	vec3 vertexPosition_worldspace = particleCenter_worldspace + CameraRight_worldspace * squareVertices.x * particleSize + CameraUp_worldspace * squareVertices.y * particleSize;

	gl_Position = projection * view * vec4(vertexPosition_worldspace, 1.0f);

	ParticleColor = color;
	
}